﻿using ELTE.TodoList.Persistence.DTO;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Text;
using System.Threading.Tasks;

namespace ELTE.TodoList.Desktop.Model
{
    public class TodoListApiService
    {
        private readonly HttpClient _client;

        public TodoListApiService(string baseAddress)
        {
            _client = new HttpClient()
            {
                BaseAddress = new Uri(baseAddress)
            };
        }

        public async Task<IEnumerable<ListDto>> LoadListsAsync()
        {
            var response = await _client.GetAsync("api/Lists/");

            if (response.IsSuccessStatusCode)
            {
                return await response.Content.ReadAsAsync<IEnumerable<ListDto>>();
            }

            throw new NetworkException("Service returned response: " + response.StatusCode);
        }

        public async Task<IEnumerable<ItemDto>> LoadItemsAsync(int listId)
        {
            var response = await _client.GetAsync($"api/Items/{listId}");

            if (response.IsSuccessStatusCode)
            {
                return await response.Content.ReadAsAsync<IEnumerable<ItemDto>>();
            }

            throw new NetworkException("Service returned response: " + response.StatusCode);
        }
    }
}
